#ifndef MISCUTILS_H
#define MISCUTILS_H

/*
   MiscUtils.h - misc helper routines

   Copyright (C) 2003, 2004 Matthias Reichl <hias@horus.com>

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include <stdio.h>
#include "DiskImage.h"

namespace MiscUtils {
	char* ShortenFilename(const char* filename, unsigned int maxlen);

	size_t EstimateDiskSize(const char* directory, ESectorLength seclen, bool withPiconame);

	bool drop_root_privileges();
	bool set_realtime_scheduling(int priority);
	bool drop_realtime_scheduling();

	inline void EatSpace(const char* &string)
	{
		if (string) {
			while (*string == ' ') {
				string++;
			}
		}
	}

};


#endif
